import Test from './helpers/test';

const requireTest = (rule: string) => (test: Test): void =>
  require(rule).default(test);

export const account = requireTest('./schemaRules/account');
export const activity = requireTest('./schemaRules/activity');
export const actor = requireTest('./schemaRules/actor');
export const agent = requireTest('./schemaRules/agent');
export const attachment = requireTest('./schemaRules/attachment');
export const authority = requireTest('./schemaRules/authority');
export const booleanValue = requireTest('./values/boolean');
export const context = requireTest('./schemaRules/context');
export const contextActivities = requireTest('./schemaRules/contextActivities');
export const definition = requireTest('./schemaRules/definition');
export const duration = requireTest('./regexValues/duration');
export const extensions = requireTest('./maps/extensions');
export const group = requireTest('./schemaRules/group');
export const subGroup = requireTest('./schemaRules/subGroup');
export const imt = requireTest('./regexValues/imt');
export const integerValue = requireTest('./values/integer');
export const interactionComponent = requireTest('./schemaRules/interactionComponent');
export const interactionType = requireTest('./regexValues/interactionType');
export const iri = requireTest('./regexValues/iri');
export const language = requireTest('./regexValues/language');
export const languageMap = requireTest('./maps/languageMap');
export const mailto = requireTest('./regexValues/mailto');
export const numberValue = requireTest('./values/number');
export const object = requireTest('./schemaRules/object');
export const result = requireTest('./schemaRules/result');
export const scaledValue = requireTest('./values/scaled');
export const score = requireTest('./schemaRules/score');
export const sha1 = requireTest('./regexValues/sha1');
export const statement = requireTest('./schemaRules/statement');
export const statementRef = requireTest('./schemaRules/statementRef');
export const stringValue = requireTest('./values/string');
export const subStatement = requireTest('./schemaRules/subStatement');
export const subStatementObject = requireTest('./schemaRules/subStatementObject');
export const timestamp = requireTest('./regexValues/timestamp');
export const uuid = requireTest('./regexValues/uuid');
export const verb = requireTest('./schemaRules/verb');
export const version = requireTest('./regexValues/version');
